// FileWriter.h: CFileWriter NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "NCachedFile.h"


/////////////////////////////////////////////////////////////////////////////
// ėpt@Co(CMediaDatâ܂܃t@Cɏo)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CMediaData		݃f[^
/////////////////////////////////////////////////////////////////////////////

class CFileWriter : public CMediaDecoder  
{
public:
	CFileWriter(IEventHandler *pEventHandler = NULL);
	virtual ~CFileWriter();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CFileWriter
	const bool OpenFile(LPCTSTR lpszFileName);
	void CloseFile(void);

	const LONGLONG GetWriteSize(void) const;
	const LONGLONG GetWriteCount(void) const;

protected:
	CNCachedFile m_OutFile;
	
	LONGLONG m_llWriteSize;
	LONGLONG m_llWriteCount;
};
